Index: GTP/trunk/Lib/Geom/shared/GTGeometry/src/libs/SimplificationMethod.cpp
===================================================================
--- GTP/trunk/Lib/Geom/shared/GTGeometry/src/libs/SimplificationMethod.cpp	(revision 1025)
+++ GTP/trunk/Lib/Geom/shared/GTGeometry/src/libs/SimplificationMethod.cpp	(revision 1526)
@@ -696,237 +1088,85 @@
 };
 
-
-//---------------------------------------------------------------------------
-//Unify the model to work with it
-//The vertices that have the same space coordinates are stored as an unique vertex
-//in order to avoid holes in the simplification
-//The necessary information to store correctly the decimation data is stored
-//---------------------------------------------------------------------------
-void SimplificationMethod::geomesh2simplifModel(void)
-{
-	std::map<_float3_,int> vertices_map; //Unique vertices (without repetitions) from all the submeshes
-	unsigned int num_final_verts = 0; //Number of unique vertices from all the submeshes
-
-	int num_final_verts2=0;
-	int num_repeated_verts=0;
-
-	int simplifindex;
-	for (size_t i=0; i<objmesh->mSubMeshCount; i++) //For all the submeshes
-	{
-		if (i	!=	indexMeshLeaves)
-		{
-			//If the model has texture information
-			if (objmesh->mSubMesh[i].mVertexBuffer->mVertexInfo & VERTEX_TEXCOORDS) 
-			{
-				//For all the vertices of each submesh
-				for (size_t j=0; j<objmesh->mSubMesh[i].mVertexBuffer->mVertexCount; j++) 
-				{
-					_float3_ auxvert(objmesh->mSubMesh[i].mVertexBuffer->mPosition[j].x, 
+//---------------------------------------------------------------------------
+//	Generate simplification model.
+//---------------------------------------------------------------------------
+void	SimplificationMethod::generateSimplifModel(void)
+{
+	int	face_index	=	0;
+
+	//	For each submesh.
+	bool added_vertices = false;
+	for (size_t	i =	0;	i	<	objmesh->mSubMeshCount;	i++)
+	{
+		//	If is not a tree leaves submesh.
+		if (i != indexMeshLeaves)
+		{
+			//	For all the vertices of each submesh.
+			for (	size_t	j	=	0;
+					j < objmesh->mSubMesh[i].mVertexBuffer->mVertexCount;
+					j++)
+			{
+				//	If the vertex is not in vertices_map, then is added.
+				M0.in_Vertex(simplif::Vec3(
+							objmesh->mSubMesh[i].mVertexBuffer->mPosition[j].x,
 							objmesh->mSubMesh[i].mVertexBuffer->mPosition[j].y,
-							objmesh->mSubMesh[i].mVertexBuffer->mPosition[j].z);
-
-					std::map<_float3_,int>::iterator mit = vertices_map.find(auxvert);
-					if (mit==vertices_map.end())
-					{
-						//If the vertex is not in vertices_map, then is added
-						simplifindex=M0.in_Vertex(simplif::Vec3(objmesh->mSubMesh[i].mVertexBuffer->mPosition[j].x, 
-									objmesh->mSubMesh[i].mVertexBuffer->mPosition[j].y,
-									objmesh->mSubMesh[i].mVertexBuffer->mPosition[j].z));
-						M0.in_Normal(simplif::Vec3(objmesh->mSubMesh[i].mVertexBuffer->mNormal[j].x, 
-									objmesh->mSubMesh[i].mVertexBuffer->mNormal[j].y,
-									objmesh->mSubMesh[i].mVertexBuffer->mNormal[j].z));
-
-						M0.in_TexCoord(simplif::Vec2(objmesh->mSubMesh[i].mVertexBuffer->mTexCoords[j].x, 
-									objmesh->mSubMesh[i].mVertexBuffer->mTexCoords[j].y));
-						vertices_map[auxvert] = num_final_verts;
-						num_final_verts ++;
-
-						std::vector<int> v;
-						submeshmap[simplifindex]=v;
-						submeshmap[simplifindex].push_back((int)i); //Add the index of the mesh that contains the vertex
-						std::vector<int> v2;
-						vertexbuffermap[simplifindex]=v2;
-						vertexbuffermap[simplifindex].push_back((int)j); //Add the index of vertex in the submesh
-
-						// Debug
-						num_final_verts2++;
-					}
-					else
-					{
-						//the vertex is already in vertices_map, so store the reference of the first one with the same space coodinates
-						simplifindex = mit->second;
-						submeshmap[simplifindex].push_back((int)i); //Submeshes that contains the vertex
-						vertexbuffermap[simplifindex].push_back((int)j); //Indices of the vertex buffers that contains the vertex
-
-						// Debug
-						num_repeated_verts++;
-					}	
-				}
-			}
-			else //the model has not texture information
-			{ 
-				//For all the vertices of each submesh
-				for (size_t j=0; j<objmesh->mSubMesh[i].mVertexBuffer->mVertexCount; j++) 
-				{
-					_float3_ auxvert(objmesh->mSubMesh[i].mVertexBuffer->mPosition[j].x, 
-							objmesh->mSubMesh[i].mVertexBuffer->mPosition[j].y,
-							objmesh->mSubMesh[i].mVertexBuffer->mPosition[j].z);
-
-					std::map<_float3_,int>::iterator mit = vertices_map.find(auxvert);
-					if (mit==vertices_map.end())
-					{
-						//If the vertex is not in vertices_map, then is added
-						simplifindex=M0.in_Vertex(simplif::Vec3(objmesh->mSubMesh[i].mVertexBuffer->mPosition[j].x, 
-									objmesh->mSubMesh[i].mVertexBuffer->mPosition[j].y,
-									objmesh->mSubMesh[i].mVertexBuffer->mPosition[j].z));
-						M0.in_Normal(simplif::Vec3(objmesh->mSubMesh[i].mVertexBuffer->mNormal[j].x, 
-									objmesh->mSubMesh[i].mVertexBuffer->mNormal[j].y,
-									objmesh->mSubMesh[i].mVertexBuffer->mNormal[j].z));
-						M0.in_TexCoord(simplif::Vec2(0.0,0.0));
-						vertices_map[auxvert] = num_final_verts;
-						num_final_verts ++;
-
-						std::vector<int> v;
-						submeshmap[simplifindex]=v;
-						submeshmap[simplifindex].push_back((int)i); //Add the index of the mesh that contains the vertex
-						std::vector<int> v2;
-						vertexbuffermap[simplifindex]=v2;
-						vertexbuffermap[simplifindex].push_back((int)j); //Add the index of vertex in the submesh
-					}
-					else
-					{
-						//the vertex is already in vertices_map, so store the reference of the first one with the same space coodinates
-						simplifindex = mit->second;
-						submeshmap[simplifindex].push_back((int)i); //Submeshes that contains the vertex
-						vertexbuffermap[simplifindex].push_back((int)j); //Indices of the vertex buffers that contains the vertex
-					}	
-				}
-			}
-			if (objmesh->mSubMesh[i].mSharedVertexBuffer)
-			{
-				printf("Shared break");
-				break;
-			}
-		}
-	}
-
-	//Create the faces
-	unsigned int base_index=0;
-
-	number_of_triangles=0; //Number of triangles of the model
-	int face_index=0;
-
-	int index_in_vertices_map0,index_in_vertices_map1,index_in_vertices_map2;
-	for (size_t i=0; i<objmesh->mSubMeshCount; i++) //For all the submeshes
-	{ 
-		if (i!=indexMeshLeaves)
-		{
-			for (Index j=0; j<objmesh->mSubMesh[i].mIndexCount; j+=3) 
-			{
-				//+1 is required because the first index in the simplification method is 1
-				//Index of the vertex in vertices_map
-				Index indice0=objmesh->mSubMesh[i].mIndex[j];
-				_float3_ auxvert0(objmesh->mSubMesh[i].mVertexBuffer->mPosition[indice0].x, 
-						objmesh->mSubMesh[i].mVertexBuffer->mPosition[indice0].y,
-						objmesh->mSubMesh[i].mVertexBuffer->mPosition[indice0].z);
-				index_in_vertices_map0=vertices_map[auxvert0] + 1;
-
-				Index indice1=objmesh->mSubMesh[i].mIndex[j+1];
-				_float3_ auxvert1(objmesh->mSubMesh[i].mVertexBuffer->mPosition[indice1].x, 
-						objmesh->mSubMesh[i].mVertexBuffer->mPosition[indice1].y,
-						objmesh->mSubMesh[i].mVertexBuffer->mPosition[indice1].z);
-				index_in_vertices_map1=vertices_map[auxvert1] + 1;
-
-				Index indice2=objmesh->mSubMesh[i].mIndex[j+2];
-				_float3_ auxvert2(objmesh->mSubMesh[i].mVertexBuffer->mPosition[indice2].x, 
-						objmesh->mSubMesh[i].mVertexBuffer->mPosition[indice2].y,
-						objmesh->mSubMesh[i].mVertexBuffer->mPosition[indice2].z);
-				index_in_vertices_map2=vertices_map[auxvert2] + 1;
-
-				//Create a triangle with its indices in vertices_map
-				face_index=M0.miin_Face(index_in_vertices_map0,index_in_vertices_map1,index_in_vertices_map2);
-
-				//igeo allows to identify the submesh that contains the triangle
-				M0.face(face_index)->igeo=(int)i;
-			}
-		}
-	}
-	number_of_triangles=face_index;
-}
-
-
-//---------------------------------------------------------------------------
-//Wrties a file with the vertices, triangles and the simplification sequence
-//---------------------------------------------------------------------------
-void SimplificationMethod::WriteOBJ(void)
-{
-	MeshSimplificationSequence::Step stepaux;
-	vector<int> v0,v1,submesh0,submesh1;
-	std::ofstream obj("salida.lod");
-	obj << "begin" << std::endl;
-	//vertices
-	for (size_t i=0; i<objmesh->mSubMeshCount; i++) 
-	{
-		for (size_t j=0; j<objmesh->mSubMesh[i].mVertexBuffer->mVertexCount; j++) 
-		{	
-			obj << "v " <<  objmesh->mSubMesh[i].mVertexBuffer->mPosition[j].x << " " <<
-				objmesh->mSubMesh[i].mVertexBuffer->mPosition[j].y << " " <<
-				objmesh->mSubMesh[i].mVertexBuffer->mPosition[j].z << " " << std::endl;
-		}
-	}
-
-
-	//faces
-	for (size_t i=0; i<objmesh->mSubMeshCount; i++) 
-	{
-		for (size_t j=0; j<objmesh->mSubMesh[i].mIndexCount; j=j+3) 
-		{	
-			obj << "f " <<  objmesh->mSubMesh[i].mIndex[j]+1 << " " << 
-				objmesh->mSubMesh[i].mIndex[j+1]+1 << " " << 
-				objmesh->mSubMesh[i].mIndex[j+2]+1 << std::endl;
-		}
-	}
-
-	obj << "end" << std::endl;
-
-	for (unsigned i=0; i<decim_data.size(); i++) 
-	{
-		stepaux = decim_data.operator [](i);
-		v0=vertexbuffermap[stepaux.mV0];  //vertexbuffer index
-		submesh0=submeshmap[stepaux.mV0]; //displacement for each submesh
-		v1=vertexbuffermap[stepaux.mV1];
-		submesh1=submeshmap[stepaux.mV1];
-		for (unsigned j=0; j<v0.size(); j++)
-		{
-			for (unsigned k=0; k<v1.size(); k++) 
-			{
-				//obtain the index of the VertexBuffer of each submesh and the displacemente by submesh
-				obj << "v% " << v1.operator [](k)+first_index_submesh[submesh1.operator [](k)] << 
-					" " << v0.operator [](j)+first_index_submesh[submesh0.operator [](j)] << " " << 
-					stepaux.x << " " << stepaux.y << " " << stepaux.z << " " << stepaux.mT0 << " " <<
-					stepaux.mT1 << " & ";
-				if (stepaux.mModfaces.size()>0) 
-				{
-					unsigned int ii=0;
-					for (ii=0; ii<stepaux.mModfaces.size()-1; ii++) 
-					{
-						obj << stepaux.mModfaces.operator [](ii) << " ";
-					}
-					obj << stepaux.mModfaces.operator [](ii) << std::endl;
-				}
-				else 
-				{ 
-					obj << std::endl; 
-				}					
-			}
-		}
-	}
-	obj.close();
-}
-
-//---------------------------------------------------------------------------
-//simplifmethod_init is executed to do some initalizations
-//simplifmethod_run is executed to do the decimation
-//Then, the simpified model is created and the decimation information is returned
+							objmesh->mSubMesh[i].mVertexBuffer->mPosition[j].z));
+
+				M0.in_Normal(simplif::Vec3(
+							objmesh->mSubMesh[i].mVertexBuffer->mNormal[j].x,
+							objmesh->mSubMesh[i].mVertexBuffer->mNormal[j].y,
+							objmesh->mSubMesh[i].mVertexBuffer->mNormal[j].z));
+
+				M0.in_TexCoord(simplif::Vec2(
+							objmesh->mSubMesh[i].mVertexBuffer->mTexCoords[j].x,
+							objmesh->mSubMesh[i].mVertexBuffer->mTexCoords[j].y));
+
+				added_vertices = true;
+			}
+		}	
+		
+		//	If is shared vertex buffer object.
+		if (objmesh->mSubMesh[i].mSharedVertexBuffer && added_vertices)
+		{
+			printf("Shared break");
+			break;
+		}
+	}
+
+	//	For each submesh.
+	for (size_t	i = 0;	i < objmesh->mSubMeshCount;	i++)
+	{
+		if (i != indexMeshLeaves)
+		{
+			for (Index	j	=	0;	j < objmesh->mSubMesh[i].mIndexCount;	j	+=	3)
+			{
+				//	+1 is required because the first index in the
+				//	simplification method is 1
+				//	Index of the vertex in vertices_map.
+				Index index0	=		objmesh->mSubMesh[i].mIndex[j];
+				
+				Index index1	=		objmesh->mSubMesh[i].mIndex[j + 1];
+				
+				Index index2	=		objmesh->mSubMesh[i].mIndex[j + 2];
+				
+				//	Create a triangle with its indices in vertices_map.
+				face_index	=	M0.miin_Face(
+						index0,
+						index1,
+						index2);
+
+				//	igeo allows to identify the submesh that contains the triangle.
+				M0.face(face_index)->igeo	=	(int)i;
+			}
+		}
+	}
+	number_of_triangles	=	face_index;
+}
+
+//---------------------------------------------------------------------------
+//	simplifmethod_init is executed to do some initalizations
+//	simplifmethod_run is executed to do the decimation
+//	Then, the simpified model is created and the decimation 
+//	information is returned.
 //---------------------------------------------------------------------------
 MeshSimplificationSequence *SimplificationMethod::Decimate(	float lod,
@@ -938,10 +1178,10 @@
 	if (simpliftype == 0)
 	{
-		//Percentage option
+		//	Percentage option.
 		simplifmethod_run((int)(number_of_triangles*lod),upb);
 	}
 	else
 	{
-		//Number of vertices option
+		//	Number of vertices option.
 		simplifmethod_runv((int)lod,upb);
 	}
@@ -953,6 +1193,8 @@
 	typedef std::vector<int> REPINDLIST;
 
-	MAPAINDIND *unique_verts_inds_by_geo = new MAPAINDIND[objmesh->mSubMeshCount]; 
-	REPINDLIST *ver_inds_rep_by_geo 	= new REPINDLIST[objmesh->mSubMeshCount]; 
+	MAPAINDIND *unique_verts_inds_by_geo =
+														new MAPAINDIND[objmesh->mSubMeshCount];
+
+	REPINDLIST *ver_inds_rep_by_geo	= new REPINDLIST[objmesh->mSubMeshCount];
 
 	//	Index counter by submesh.
@@ -964,6 +1206,6 @@
 	}
 
-
 	//	Construct the model.
+	std::cout << "M0.faceCount(): " << M0.faceCount() << std::endl;
 	for (int	i = 0;	i < M0.faceCount();	i++)
 	{
@@ -976,25 +1218,37 @@
 
 			//	Insert to each submesh its triangles.
-			std::map<int,int>::iterator findit = unique_verts_inds_by_geo[igeo].find(auxface->vertex(0)->validID());
+			std::map<int,int>::iterator findit =
+				unique_verts_inds_by_geo[igeo].find(auxface->vertex(0)->validID());
+			
 			if (findit == unique_verts_inds_by_geo[igeo].end())
 			{
 				//	If it is not added... add and map it.
-				unique_verts_inds_by_geo[igeo][auxface->vertex(0)->validID()] = inextvert[igeo];
+				unique_verts_inds_by_geo[igeo][auxface->vertex(0)->validID()] =
+																														inextvert[igeo];
+				
 				inextvert[igeo]++;
-			}			
-			findit = unique_verts_inds_by_geo[igeo].find(auxface->vertex(1)->validID());
+			}
+
+			findit =
+				unique_verts_inds_by_geo[igeo].find(auxface->vertex(1)->validID());
+			
 			if (findit == unique_verts_inds_by_geo[igeo].end())
 			{
 				//	If it is not added... add and map it.
-				unique_verts_inds_by_geo[igeo][auxface->vertex(1)->validID()] = inextvert[igeo];
+				unique_verts_inds_by_geo[igeo][auxface->vertex(1)->validID()] =
+																														inextvert[igeo];
 				inextvert[igeo]++;
-			}			
-			findit = unique_verts_inds_by_geo[igeo].find(auxface->vertex(2)->validID());
+			}
+			
+			findit = 
+				unique_verts_inds_by_geo[igeo].find(auxface->vertex(2)->validID());
+			
 			if (findit == unique_verts_inds_by_geo[igeo].end())
 			{
 				//	If it is not added... add and map it.
-				unique_verts_inds_by_geo[igeo][auxface->vertex(2)->validID()] = inextvert[igeo];
+				unique_verts_inds_by_geo[igeo][auxface->vertex(2)->validID()] = 
+																														inextvert[igeo];
 				inextvert[igeo]++;
-			}			
+			}
 
 			//	Total number of indices by submesh.
@@ -1043,8 +1297,9 @@
 	bool copiedShared = false;
 
+	//	For each submesh.
 	for (size_t	i = 0;	i < objmesh->mSubMeshCount;	i++)
 	{
-		mGeoMesh->mSubMesh[i].mStripCount					=	0;
-		mGeoMesh->mSubMesh[i].mStrip							=	NULL;
+		mGeoMesh->mSubMesh[i].mStripCount	=	0;
+		mGeoMesh->mSubMesh[i].mStrip			=	NULL;
 
 		mGeoMesh->
@@ -1060,5 +1315,5 @@
 			{
 				mGeoMesh->mSubMesh[i].mBones.push_back(objmesh->
-						mSubMesh[i].mBones[j]);
+																				mSubMesh[i].mBones[j]);
 			}
 		}
@@ -1068,6 +1323,7 @@
 			//	Indices vectors.
 			mGeoMesh->mSubMesh[i].mIndexCount	=	ver_inds_rep_by_geo[i].size();
+			
 			mGeoMesh->mSubMesh[i].mIndex			=	new Index[mGeoMesh->
-				mSubMesh[i].mIndexCount];
+																						mSubMesh[i].mIndexCount];
 
 			//	Store the indices.
@@ -1075,5 +1331,8 @@
 			{
 				//	Obtain the indices that point at VertexBuffer.
-				mGeoMesh->mSubMesh[i].mIndex[j]	=	unique_verts_inds_by_geo[i].operator [](ver_inds_rep_by_geo[i].operator [](j));
+				mGeoMesh->mSubMesh[i].mIndex[j]	=
+					unique_verts_inds_by_geo[i].
+								operator [](ver_inds_rep_by_geo[i].
+								operator [](j));
 			}
 
@@ -1096,11 +1355,19 @@
 			}
 
-			mGeoMesh->mSubMesh[i].mVertexBuffer->mVertexCount	=	unique_verts_inds_by_geo[i].size();
-			mGeoMesh->mSubMesh[i].mVertexBuffer->mVertexInfo	=	objmesh->mSubMesh[i].mVertexBuffer->mVertexInfo;
+			mGeoMesh->mSubMesh[i].mVertexBuffer->mVertexCount	=
+																	unique_verts_inds_by_geo[i].size();
+			
+			mGeoMesh->mSubMesh[i].mVertexBuffer->mVertexInfo	=
+											objmesh->mSubMesh[i].mVertexBuffer->mVertexInfo;
 
 			//	Allocate memory for position, normal and texutre coordinates.
-			mGeoMesh->mSubMesh[i].mVertexBuffer->mPosition	=	new Vector3[mGeoMesh->mSubMesh[i].mVertexBuffer->mVertexCount];
-			mGeoMesh->mSubMesh[i].mVertexBuffer->mNormal		=	new Vector3[mGeoMesh->mSubMesh[i].mVertexBuffer->mVertexCount];
-			mGeoMesh->mSubMesh[i].mVertexBuffer->mTexCoords	=	new Vector2[mGeoMesh->mSubMesh[i].mVertexBuffer->mVertexCount];
+			mGeoMesh->mSubMesh[i].mVertexBuffer->mPosition	=
+						new Vector3[mGeoMesh->mSubMesh[i].mVertexBuffer->mVertexCount];
+			
+			mGeoMesh->mSubMesh[i].mVertexBuffer->mNormal		=
+						new Vector3[mGeoMesh->mSubMesh[i].mVertexBuffer->mVertexCount];
+			
+			mGeoMesh->mSubMesh[i].mVertexBuffer->mTexCoords	=
+						new Vector2[mGeoMesh->mSubMesh[i].mVertexBuffer->mVertexCount];
 
 			for (	MAPAINDIND::iterator mapit = unique_verts_inds_by_geo[i].begin();
@@ -1114,16 +1381,22 @@
 				//	Vertex coordinate.
 				//	Construction of the submeshes.
-				Vector3 v3((Real)M0.vertex(isrc)->operator [](0),
-						(Real)M0.vertex(isrc)->operator [](1),
-						(Real)M0.vertex(isrc)->operator [](2));
-				mGeoMesh->mSubMesh[i].mVertexBuffer->mPosition[idst]=v3;
+				Vector3 v3(	(Real)M0.vertex(isrc)->operator [](0),
+										(Real)M0.vertex(isrc)->operator [](1),
+										(Real)M0.vertex(isrc)->operator [](2));
+				
+				mGeoMesh->mSubMesh[i].mVertexBuffer->mPosition[idst]	=	v3;
 
 				//	Normal coordinates.
-				Vector3 v3n((Real)M0.normal(isrc)(0), (Real)M0.normal(isrc)(1), (Real)M0.normal(isrc)(2));
-				mGeoMesh->mSubMesh[i].mVertexBuffer->mNormal[idst]=v3n;
+				Vector3 v3n(	(Real)M0.normal(isrc)(0),
+											(Real)M0.normal(isrc)(1),
+											(Real)M0.normal(isrc)(2));
+				
+				mGeoMesh->mSubMesh[i].mVertexBuffer->mNormal[idst]	=	v3n;
 
 				//	Texture coordinates.
-				Vector2 v2((Real)M0.texcoord(isrc)(0), (Real)M0.texcoord(isrc)(1));
-				mGeoMesh->mSubMesh[i].mVertexBuffer->mTexCoords[idst]=v2;
+				Vector2 v2(	(Real)M0.texcoord(isrc)(0),
+										(Real)M0.texcoord(isrc)(1));
+				
+				mGeoMesh->mSubMesh[i].mVertexBuffer->mTexCoords[idst]	=	v2;
 			}
 		}
@@ -1131,22 +1404,32 @@
 		{
 			//	Leaves mesh.
-			mGeoMesh->mSubMesh[i].mIndexCount=objmesh->mSubMesh[i].mIndexCount;
-			mGeoMesh->mSubMesh[i].mIndex=new Index[mGeoMesh->mSubMesh[i].mIndexCount];
+			mGeoMesh->mSubMesh[i].mIndexCount	=	objmesh->mSubMesh[i].mIndexCount;
+			
+			mGeoMesh->mSubMesh[i].mIndex	=		new Index[mGeoMesh->mSubMesh[i].mIndexCount];
 
 			//	Copy the leaves submesh indexes.
-			for (unsigned int j=0; j<mGeoMesh->mSubMesh[i].mIndexCount; j++)
+			for (unsigned int	j	=	0;	j < mGeoMesh->mSubMesh[i].mIndexCount;	j++)
 			{	
-				mGeoMesh->mSubMesh[i].mIndex[j]=objmesh->mSubMesh[i].mIndex[j];
+				mGeoMesh->mSubMesh[i].mIndex[j]	=	objmesh->mSubMesh[i].mIndex[j];
 			}
 
 			//	Copy the leaves submesh vertices.
-			mGeoMesh->mSubMesh[i].mVertexBuffer=new VertexBuffer();
-			mGeoMesh->mSubMesh[i].mVertexBuffer->mVertexCount=objmesh->mSubMesh[i].mVertexBuffer->mVertexCount;
-			mGeoMesh->mSubMesh[i].mVertexBuffer->mVertexInfo=objmesh->mSubMesh[i].mVertexBuffer->mVertexInfo;
+			mGeoMesh->mSubMesh[i].mVertexBuffer	=	new VertexBuffer();
+			
+			mGeoMesh->mSubMesh[i].mVertexBuffer->mVertexCount	=
+														objmesh->mSubMesh[i].mVertexBuffer->mVertexCount;
+			
+			mGeoMesh->mSubMesh[i].mVertexBuffer->mVertexInfo	=
+														objmesh->mSubMesh[i].mVertexBuffer->mVertexInfo;
 
 			//	Allocate memory for position, normal and texture coordinates.
-			mGeoMesh->mSubMesh[i].mVertexBuffer->mPosition=new Vector3[mGeoMesh->mSubMesh[i].mVertexBuffer->mVertexCount];
-			mGeoMesh->mSubMesh[i].mVertexBuffer->mNormal=new Vector3[mGeoMesh->mSubMesh[i].mVertexBuffer->mVertexCount];
-			mGeoMesh->mSubMesh[i].mVertexBuffer->mTexCoords=new Vector2[mGeoMesh->mSubMesh[i].mVertexBuffer->mVertexCount];
+			mGeoMesh->mSubMesh[i].mVertexBuffer->mPosition	=
+							new Vector3[mGeoMesh->mSubMesh[i].mVertexBuffer->mVertexCount];
+			
+			mGeoMesh->mSubMesh[i].mVertexBuffer->mNormal	=
+							new Vector3[mGeoMesh->mSubMesh[i].mVertexBuffer->mVertexCount];
+			
+			mGeoMesh->mSubMesh[i].mVertexBuffer->mTexCoords	=
+							new Vector2[mGeoMesh->mSubMesh[i].mVertexBuffer->mVertexCount];
 
 			for (	unsigned int j = 0;
@@ -1155,16 +1438,29 @@
 			{
 				//	Position.
-				mGeoMesh->mSubMesh[i].mVertexBuffer->mPosition[j].x=objmesh->mSubMesh[i].mVertexBuffer->mPosition[j].x;
-				mGeoMesh->mSubMesh[i].mVertexBuffer->mPosition[j].y=objmesh->mSubMesh[i].mVertexBuffer->mPosition[j].y;
-				mGeoMesh->mSubMesh[i].mVertexBuffer->mPosition[j].z=objmesh->mSubMesh[i].mVertexBuffer->mPosition[j].z;
+				mGeoMesh->mSubMesh[i].mVertexBuffer->mPosition[j].x	=
+									objmesh->mSubMesh[i].mVertexBuffer->mPosition[j].x;
+				
+				mGeoMesh->mSubMesh[i].mVertexBuffer->mPosition[j].y	=
+									objmesh->mSubMesh[i].mVertexBuffer->mPosition[j].y;
+				
+				mGeoMesh->mSubMesh[i].mVertexBuffer->mPosition[j].z	=
+									objmesh->mSubMesh[i].mVertexBuffer->mPosition[j].z;
 
 				//	Normals.
-				mGeoMesh->mSubMesh[i].mVertexBuffer->mNormal[j].x=objmesh->mSubMesh[i].mVertexBuffer->mNormal[j].x;
-				mGeoMesh->mSubMesh[i].mVertexBuffer->mNormal[j].y=objmesh->mSubMesh[i].mVertexBuffer->mNormal[j].y;
-				mGeoMesh->mSubMesh[i].mVertexBuffer->mNormal[j].z=objmesh->mSubMesh[i].mVertexBuffer->mNormal[j].z;
+				mGeoMesh->mSubMesh[i].mVertexBuffer->mNormal[j].x	=
+									objmesh->mSubMesh[i].mVertexBuffer->mNormal[j].x;
+				
+				mGeoMesh->mSubMesh[i].mVertexBuffer->mNormal[j].y	=
+									objmesh->mSubMesh[i].mVertexBuffer->mNormal[j].y;
+				
+				mGeoMesh->mSubMesh[i].mVertexBuffer->mNormal[j].z	=
+									objmesh->mSubMesh[i].mVertexBuffer->mNormal[j].z;
 
 				//	Textures.
-				mGeoMesh->mSubMesh[i].mVertexBuffer->mTexCoords[j].x=objmesh->mSubMesh[i].mVertexBuffer->mTexCoords[j].x;
-				mGeoMesh->mSubMesh[i].mVertexBuffer->mTexCoords[j].y=objmesh->mSubMesh[i].mVertexBuffer->mTexCoords[j].y;
+				mGeoMesh->mSubMesh[i].mVertexBuffer->mTexCoords[j].x	=
+									objmesh->mSubMesh[i].mVertexBuffer->mTexCoords[j].x;
+				
+				mGeoMesh->mSubMesh[i].mVertexBuffer->mTexCoords[j].y	=
+									objmesh->mSubMesh[i].mVertexBuffer->mTexCoords[j].y;
 			}
 		}
@@ -1176,5 +1472,5 @@
 
 	//	Store the simplification steps in MeshSimplificationSequence.
-	int acum	=	0;
+	int	acum	=	0;
 
 	for (size_t i	=	0; i < objmesh->mSubMeshCount; i++)
@@ -1192,64 +1488,9 @@
 	}
 
-	MeshSimplificationSequence::Step stepaux, newstep;
-	vector<int> v0,v1,submesh0,submesh1;
-	MeshSimplificationSequence *msimpseq;
-
-	msimpseq	=	new MeshSimplificationSequence();
-
-	for (unsigned i = 0;	i < decim_data.size();	i++) 
-	{
-		stepaux		=	decim_data.operator [](i);
-		v0				=	vertexbuffermap[stepaux.mV0];  // vertexbuffer index
-		submesh0	=	submeshmap[stepaux.mV0]; // displacement by submesh
-		v1				=	vertexbuffermap[stepaux.mV1];
-		submesh1	=	submeshmap[stepaux.mV1];
-
-		for (unsigned j = 0;	j < v0.size();	j++)
-		{
-			for (unsigned k = 0;	k < v1.size(); k++)
-			{
-				//	Obtain the submesh index in VertexBuffer
-				//	and the displacement by submesh
-				newstep.mV0	=	v0.operator [](j)+first_index_submesh[submesh0.operator [](j)];
-				newstep.mV1	=	v1.operator [](k)+first_index_submesh[submesh1.operator [](k)];
-				newstep.x		=	stepaux.x;
-				newstep.y		=	stepaux.y;
-				newstep.z		=	stepaux.z;
-
-				// mT0 y mT1 are unique triangles identifiers
-				// returned by the simplification method
-				newstep.mT0	=	stepaux.mT0;
-				newstep.mT1	=	stepaux.mT1;
-
-				if (j == v0.size() - 1 && k == v1.size() - 1)
-				{
-					newstep.obligatorio	=	0;
-				}
-				else
-				{
-					newstep.obligatorio	=	1;
-				}
-
-				if (j == 0 && k == 0)
-				{
-					//	First simplification step.
-					//	unique triangle identifiers 
-					//	returned by the simplification method.
-					newstep.mModfaces	=	stepaux.mModfaces;
-				}
-				else 
-				{
-					std::vector<Index>	vvacio;
-
-					newstep.mModfaces	=	vvacio;
-				}
-
-				msimpseq->mSteps.push_back(newstep);
-			}
-		}
-	}
-
-	// WriteOBJ();
+	vector<int>	v0;
+	vector<int>	v1;
+	vector<int>	submesh0;
+	vector<int>	submesh1;
+
 	return msimpseq;
 }
